/**
 * Created with WebStorm.
 * User: gp
 * Date: 16-3-3
 *
 */

import expect from 'expect'
import React from 'react';
import { mount, shallow } from 'enzyme';
import immutable from 'immutable'
import NativeNavBar from '../../src/page/NativeNavBar'


describe('NativeNavBar', () => {

    describe('component', () => {

        function setup(props = {}){
            const wrapper = shallow(<NativeNavBar {...props} />);
            return wrapper;
        }

            var opts =  {
                    scope:{pageId:1},
                    navOpt:{
                        onBackClick:()=>{},
                        onCloseClick: ()=>{},
                        right:{
                            type:'menu',
                            item:[
                                {text:'tx1',onClick:()=>{}},
                                {text:'tx2',onClick:()=>{}}
                            ]
                        }
                    }
            };

            function cloneOpts(){
                return immutable.Map(opts).toJS();
            }

            it('预期按正确的层次结构渲染', () => {
                const wrapper = setup(cloneOpts());
                expect(wrapper.hasClass('navbar-native')).toBe(true);
            })

            it('传递给native的navbar配置应该被解析成正确的字符串路径', ()=>{
                const wrapper = setup(cloneOpts()).instance();
                let cfg = wrapper._wrapConfig(wrapper.props);
                expect(cfg.onBackClick).toBe('executePageClick("onBackClick",1)');
                expect(cfg.onCloseClick).toBe('executePageClick("onCloseClick",1)');
                expect(cfg.right.item[0].onClick).toBe('executePageClick("right/item/0/onClick",1)');
                expect(cfg.right.item[1].onClick).toBe('executePageClick("right/item/1/onClick",1)');
            })

            it('传递给native的navbar配置,右侧是按钮时,事件应该被解析成正确的字符串路径',()=>{
                let opt = cloneOpts();
                opt.navOpt.right = {type:'button',item:{text:'s',onClick:()=>{}}}
                const wrapper = setup(opt).instance();
                let cfg = wrapper._wrapConfig(wrapper.props);
                expect(cfg.right.item.onClick).toBe('executePageClick("right/item/onClick",1)');
            })

    })

})
